#include "\x\cba\addons\main\script_macros_common.hpp"
/*
    Tekijä: Tuntematon
    versio 3.0

    Kuvaus:
        Tekee tehtävään aloitusmerkit ryhmille ja ajoneuvoille.

    Muuttujia:
        Jos et halua että tämä scripti ajetaan tehtävässä. Laita inittiin seuraava.
        AFI_Aloitus_Merkit = false;

        Laita tämä RJ tai ajoneuvon slottiin jos et tahdo että sen kohdalle tehdään merkki.
        this setVariable ["AFI_Ryhma_Merkki",false];

        Jos haluat vaihtaa ajoneuvo nimeä. Laita tämä sen inittiin.
        this setVariable["displayName", "BATMOBIILI!"];

        Jos et halua että liittolaisten alotuspaikat näkyvät. Laita inittiin seuraava.
        AFI_Liittolaiseten_Merkit = True;

        Jos haluat vaihtaa tehtävässä tekstit rallienganniksi. Laita seuraava muuttuja trueksi.
        AFI_Merkit_Lontoo = true;

        Jos tehtävässä siirretään yksiköiden paikkaa alussa. Voit käskeä servuria odottamaan laitamalla.
        TUN_Servuri_Odota = True;
        Ja kun haluat että servuri jatkaa scriptin ajamista. (Servuri ottaa ryhmien ja ajoneuvojen paikat talteen. Tämän jälkeen jos vielä siirrät paikkaa. Ei merkit ole oikein.)
        TUN_Servuri_Odota = False;

    Käyttö.
        init.sqf:

            [] execVM "merkit.sqf";

        Description.ext:

            class CfgFunctions
            {
                class myTag
                {
                    class myCategory
                    {
                        class myFunction
                        {
                            preInit = 1;
                            file = "merkit_preinit.sqf";
                        };
                    };
                };
            };

*/

if (isMultiplayer && !isServer) then
{
    if (isNull player) then
    {
        waitUntil{(!isNull player)};
        uiSleep 1;
    };

    if (time == 0) then {waitUntil {(!isNull findDisplay 53)}};
};




//katsotaan tarviiko scriptaa ajaa.
ISNILS(AFI_Aloitus_Merkit,true);
if (!(AFI_Aloitus_Merkit)) exitwith {};

//Servu tallentaa kaikki ryhmien ja rensselien infot. Ja jakaa ne pelaajille. Tämä siksi että voi JIP milloin vaan ja saa oikeat infot.
if (isServer) then
{
ISNILS(TUN_Servuri_Odota,false);
waitUntil {!(TUN_Servuri_Odota)};
ISNILS(TUN_SERVU_VALMIS,false);
if (TUN_SERVU_VALMIS) exitwith {};


    //////////
    //Ryhmät//
    //////////
    {
        private ["_pomo", "_osapuoli", "_RyhmanTyyppi", "_parametrit"];
        _pomo = leader (_x);

        if (_pomo getVariable ["AFI_Ryhma_Merkki", true]) then

        {
            _osapuoli = switch (side _pomo) do
            {
                case west: { "b" };
                case east: { "o" };
                default { "n" }
            };

            if !(format ["%1", group _pomo] find "10" == -1) then
            {
                _RyhmanTyyppi = format ["%1_hq", _osapuoli]
            }
            else
            {
                _RyhmanTyyppi = format ["%1_inf", _osapuoli]
            };

            _parametrit = [
                            side _pomo, //ryhmän puoli
                            format ["%1", group _pomo], //Merkin nimi
                            getpos _pomo, // Ryhmän sijainti
                            _RyhmanTyyppi,  //Johto vai normi ryhmä
                            [side _pomo, true ] call BIS_fnc_sideColor, //rymänväri
                            format ["%1", group _pomo] select [2] //ryhmän Groupid
                            ];

            TUN_Ryhma_Parametrit pushBack _parametrit;
        };
    } forEach allGroups;


    ///////////////////////////
    //TUN_Ajoneuvomerkkien_ID//
    ///////////////////////////

    {
        private ["_VehkeenPuoliSTR", "_VehkeenTeksti", "_VehkeenRGBvari", "_VehkeenPuoli", "_parametrit"];
        _VehkeenPuoliSTR =  toLower (_x getVariable "AFI_vehicle_gear");

        if (_x getVariable ["AFI_Ryhma_Merkki", true] && !(isNil "_VehkeenPuoliSTR")) then
        {
            if (_x isKindof "LandVehicle" || _x isKindof "Air" || _x isKindOf "Ship" || _x isKindOf "Static" || _x isKindOf "thing") then
            {
                _VehkeenTeksti = str(_x getVariable "displayName");

                _VehkeenRGBvari = switch (_VehkeenPuoliSTR) do
                {
                    case "west": {[0,0.3,0.6,1]};
                    case "east": {[0.5,0,0,1]};
                    case "guer": {[0,0.5,0,1]};
                    default {[0.4,0,0.5,1]}
                };

                _VehkeenPuoli = switch (_VehkeenPuoliSTR) do
                {
                    case "west": {west};
                    case "east": {east};
                    case "guer": {resistance};
                    default {civilian}
                };

                ISNILS(_VehkeenTeksti,str getText (configFile/"CfgVehicles"/typeOf _x/"displayName"));

                _parametrit = [_VehkeenPuoliSTR, //Laitoksen Side stringinä.
                                getPos _x,  //Laitoksen sijainti.
                                getDir _x,  //Laitoksen suunta.
                                str(typeOf _x), //Laitoksen clasname
                                _VehkeenTeksti, //Laitoksen Nimi joka tulee kartalle.
                                _VehkeenRGBvari, //Laitoksen Väri
                                _VehkeenPuoli //Laitoksen side.
                                ];

                TUN_Ajoneuvo_Parametrit pushBack _parametrit;
            };
        };
    } forEach vehicles;

    TUN_SERVU_VALMIS = true;

    publicVariable "TUN_Ajoneuvo_Parametrit";
    publicVariable "TUN_Ryhma_Parametrit";
    publicVariable "TUN_SERVU_VALMIS";
};

if (!hasInterface) exitWith {}; //Servuri jatkaa matkaa muille maille.










///////////////////////////////////
//Servujutut ohi. Loput locaalia.//
///////////////////////////////////

waitUntil {!isNull player && hasInterface && missionNamespace getVariable "TUN_SERVU_VALMIS"};
if (typeOf player == "VirtualSpectator_F") exitwith {}; //Ei aja spectasloteille.




    ISNILS(TUN_Ajettuscripta,false);
    ISNILS(AFI_Liittolaiseten_Merkit,true);

    if (TUN_Ajettuscripta) exitwith {player commandChat "Tehtävässä ajetaan aloituspaikan merkkaus scripta useampaan kerntaa. Ei aiheuta kuitenkaan ongelmia. T:Tuntematon"};
    TUN_Ajettuscripta = true;
    TUN_Ryhma_Parametrit = missionNamespace getVariable "TUN_Ryhma_Parametrit";
    TUN_Ajoneuvo_Parametrit = missionNamespace getVariable "TUN_Ajoneuvo_Parametrit";


//////////
//Ryhmät//
//////////

{
    _x call {
        params ["_RyhmanPuoli","_Merkinnimi","_RyhmanSijainti","_RyhmanTyyppi","_RyhmanVari","_RyhmanGroup"];

        _liittolainen = false;
        if (AFI_Liittolaiseten_Merkit) then
        {
            _liittolainen = [side player, _RyhmanPuoli] call BIS_fnc_sideIsFriendly;
        };

        if (side player == _RyhmanPuoli || _liittolainen) then
        {

            TUN_JV_Merkit pushBack _Merkinnimi; //JV Merkit talteen

            _merk = createMarkerLocal [_Merkinnimi, _RyhmanSijainti];
            _merk setMarkerShapeLocal "ICON";
            _merk setMarkerTypeLocal _RyhmanTyyppi;
            _merk setMarkerSizeLocal [0.7,0.7];
            _merk setMarkerColorLocal _RyhmanVari;
            _merk setMarkerTextLocal _RyhmanGroup;
        };
    };
} forEach TUN_Ryhma_Parametrit;

[] call  TUN_fnc_Luuskine_Merkit; // Tehdään ajoneuvomerkit.


//tehdään briiffiin täbi jossa voi säätää merkkien näkyvyyttä.
ISNILS(AFI_Merkit_Lontoo,false);

if (AFI_Merkit_Lontoo) then
{
    player createDiarySubject ["Start Markers","Start Markers"];

    player createDiaryRecord ["Start Markers",["Merkit ON/OF", "<font size=20><execute expression='[1] call TUN_fnc_Kaikkien_Merkkien_Tila;'>All Markers On</execute></font>"]];

    player createDiaryRecord ["Start Markers",["Merkit ON/OF", "<font size=20><execute expression='[0] call TUN_fnc_Kaikkien_Merkkien_Tila'>All Markers Off</execute></font>"]];

    player createDiaryRecord ["Start Markers",["Merkit ON/OF", "<font size=20><execute expression='[1] call TUN_fnc_AjoneuvoMerkkien_Tila;'>Vehicle Markers On</execute></font>"]];

    player createDiaryRecord ["Start Markers",["Merkit ON/OF", "<font size=20><execute expression='[0] call TUN_fnc_AjoneuvoMerkkien_Tila;'>Vehicle Markers Off</execute></font>"]];

    player createDiaryRecord ["Start Markers",["Merkit ON/OF", "<font size=20><execute expression='[1] call TUN_fnc_RyhmaMerkkien_Tila;'>Group Markers On</execute></font>"]];

    player createDiaryRecord ["Start Markers",["Merkit ON/OF", "<font size=20><execute expression='[0] call TUN_fnc_RyhmaMerkkien_Tila;'>Group Markers Off</execute></font>"]];

    player createDiaryRecord ["Start Markers",["Merkit ON/OF", "<font size=20><execute expression='[1] call TUN_fnc_AjoneuvoMerkkien_Tekstin_Tila;'>Vehicle Marker Texts On</execute></font>"]];

    player createDiaryRecord ["Start Markers",["Merkit ON/OF", "<font size=20><execute expression='[0] call TUN_fnc_AjoneuvoMerkkien_Tekstin_Tila;'>Vehicle Marker Texts Off</execute></font>"]];

    player createDiaryRecord ["Start Markers",["Merkit ON/OF", "<font color='#4F4F4F' size='8'>Made by Tuntematon @ ArmaFinland.fi</font><br/>"]];
}
else
{
    player createDiarySubject ["Aloitusmerkit","Aloitusmerkit"];

    player createDiaryRecord ["Aloitusmerkit",["Merkit ON/OF", "<font size=20><execute expression='[1] call TUN_fnc_Kaikkien_Merkkien_Tila;'>Kaikki Merkit Päälle</execute></font>"]];

    player createDiaryRecord ["Aloitusmerkit",["Merkit ON/OF", "<font size=20><execute expression='[0] call TUN_fnc_Kaikkien_Merkkien_Tila'>Kaikki Merkit Pois</execute></font>"]];

    player createDiaryRecord ["Aloitusmerkit",["Merkit ON/OF", "<font size=20><execute expression='[1] call TUN_fnc_AjoneuvoMerkkien_Tila;'>Ajoneuvomerkit Päälle</execute></font>"]];

    player createDiaryRecord ["Aloitusmerkit",["Merkit ON/OF", "<font size=20><execute expression='[0] call TUN_fnc_AjoneuvoMerkkien_Tila;'>Ajoneuvomerkit Pois</execute></font>"]];

    player createDiaryRecord ["Aloitusmerkit",["Merkit ON/OF", "<font size=20><execute expression='[1] call TUN_fnc_RyhmaMerkkien_Tila;'>Ryhmämerkit Päälle</execute></font>"]];

    player createDiaryRecord ["Aloitusmerkit",["Merkit ON/OF", "<font size=20><execute expression='[0] call TUN_fnc_RyhmaMerkkien_Tila;'>Ryhmämerkit Pois</execute></font>"]];

    player createDiaryRecord ["Aloitusmerkit",["Merkit ON/OF", "<font size=20><execute expression='[1] call TUN_fnc_AjoneuvoMerkkien_Tekstin_Tila;'>Ajoneuvomerkkien Tekstit Päälle.</execute></font>"]];

    player createDiaryRecord ["Aloitusmerkit",["Merkit ON/OF", "<font size=20><execute expression='[0] call TUN_fnc_AjoneuvoMerkkien_Tekstin_Tila;'>Ajoneuvomerkkien Tekstit Pois.</execute></font>"]];

    player createDiaryRecord ["Aloitusmerkit",["Merkit ON/OF", "<font color='#4F4F4F' size='8'>Tehnyt Tuntematon @ ArmaFinland.fi</font><br/>"]];

    player createDiaryRecord ["Diary",["Aloitusmerkit Scripti","Tehtävässä on käytössä aloistupakat merkkaava Scripti. Voit muokata mitkä merkit näkyy valitsemalla" +(createDiaryLink ["Aloitusmerkit", player, " ''AloitusMerkit'' "])+ "vasemmalta.<br/>Merkit piiloitetaan safestartin jälkeen. Ne saa uudelleen näkyviin " +(createDiaryLink ["Aloitusmerkit", player, " ''AloitusMerkit'' "])+ " valikosta."]];
};



[{time > 1},
{
    TUN_Display = 12;
    if (TUN_Ajoneuvo_Merkit_Paalla) then {[0] call TUN_fnc_AjoneuvoMerkkien_Tila};
    if !(TUN_Ajoneuvo_Merkit_Paalla) then {[1] call TUN_fnc_AjoneuvoMerkkien_Tila};
}] call CBA_fnc_waitUntilAndExecute; //vaihtaa kartan idc oikeaksti pelin alettua jotta ajoneuvo merkit näkyy.



//piiloittaa merkit safestartin jälkeen. Jokainen voi laittaa ne kuitenkin päälle jos niin haluaa itse uudestaan.
[{time > 60*("afi_safeStart_duration" call BIS_fnc_getParamValue)}, {[0] call TUN_fnc_Kaikkien_Merkkien_Tila;}] call CBA_fnc_waitUntilAndExecute;



player addEventHandler ["killed",{[0] call TUN_fnc_Kaikkien_Merkkien_Tila}];

